﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;
using System.Collections.Specialized;
using System.ServiceModel;

using BSC;
using EmrDatastructure;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.Validation;
using EmrLogger;


namespace EmrDAL
{
    public partial class EmrService : IEmrService
    {
        public virtual void CreateEmrSmoking(EmrSmoking r)
        {
            try
            {
                using (var context = new EmrContext())
                {
                    context.Smoking.Add(r);
                    context.SaveChanges();
                }
            }
            catch (Exception ex)
            {
                LogAndThrow.Log("Error CreateEmrSmoking", ex);
            }
        }
        public virtual EmrSmoking ReadEmrSmoking(string emrDemographicId)
        {
            try
            {
                using (var context = new EmrContext())
                {
                    return context.Smoking.Where(s => s.EmrDemographicId == emrDemographicId).FirstOrDefault();
                }
            }
            catch (Exception ex)
            {
                LogAndThrow.Log("Error ReadEmrSmoking", ex);
                return null;
            }
        }
        public virtual void UpdateEmrSmoking(EmrSmoking r)
        {
            try
            {
                using (var context = new EmrContext())
                {
                    context.Smoking.Attach(r);
                    context.Entry(r).State = EntityState.Modified;
                    context.SaveChanges();
                }
            }
            catch (Exception ex)
            {
                LogAndThrow.Log("Error UpdateEmrSmoking", ex);
            }
        }
        public virtual void DeleteEmrSmoking(int id)
        {
            LogAndThrow.Log("Error DeleteEmrSmoking should never be called");
        }

    }
}
